#!/bin/bash

if [ $# -ne 1 ]; then
	echo "Usage $0 <file>"
	exit 1
fi

fl=$1

cols=5
lines=`wc -l "${fl}" | awk '{ print $1; }'`
rows=`echo "${lines} / ${cols}" | bc`
reminder=`echo "${lines} % ${cols}" | bc`
if [ $reminder -ne 0 ]; then
	echo "Non zero reminder $reminder"
	exit 1
fi

concat_str=""
for ((i=0;i<$cols;i++)); do
	let from="$i * $rows + 1"
	let to="$from + $rows - 1"
	tf="/tmp/tf${i}"
	cat "${fl}" | linex "${from}"-"${to}" | awk '{print $1$2;}' > ${tf}
	concat_str="${concat_str} ${tf}"
done

paste ${concat_str}

for ((i=0;i<$cols;i++)); do
	rm -f "/tmp/tf${i}"
done
