
# Copyright (C) 2009 Tudor Marian <tudor.marian@cornell.edu>

import sys

SYNC_BITS=2
PAYLOAD_BITS=64
BITS_PER_LINE=(SYNC_BITS+PAYLOAD_BITS)

def parse_bit(bit):
	bit = int(bit)
	assert bit == 1 or bit == 0
	return bit
#end parse_bit

def main():
	if len(sys.argv) != 2:
		sys.stderr.write('Usage %s <input-file> \n' % \
			sys.argv[0])
		sys.exit()
	
	f = open(sys.argv[1], 'r')
	
	sys.stdout.write('hbitstream = [\\\n')
	for line in f:
		line = line.strip()
		if not line or line[0] == '#':
			continue
		if len(line) < BITS_PER_LINE:
			sys.stderr.write('Less than %d bits per line, skipping\n' \
				% BITS_PER_LINE)
			continue
		if len(line) > BITS_PER_LINE:
			sys.stderr.write('Bug, more than %d bits per line\n' % BITS_PER_LINE)
			sys.exit(1)
		
		sync = ( parse_bit(line[0]) << 1 ) | parse_bit(line[1])
		
		payload = 0
		for i in range(PAYLOAD_BITS / 8):
			for j in range((i*8+8)-1, i*8-1, -1):
				payload = (payload << 1) | parse_bit(line[j+2])
		sys.stdout.write('(0x%1x, 0x%016x),\\\n' % (sync, payload))
	sys.stdout.write(']\n');
# end main

if __name__ == "__main__":
	main()
