
# Copyright (C) 2009 Tudor Marian <tudor.marian@cornell.edu>

from common64b66b import *

byte_range_reversed = range((64 / 8) -1, -1, -1)
bit_range = range(8)

def err_usage():
	sys.stderr.write('Usage %s [-p (66 bit per line)] <bitstream file>\n' \
		% sys.argv[0])
	sys.exit(1)
#end err_usage

def main():
	if len(sys.argv) != 2 and len(sys.argv) != 3:
		err_usage()
	bitstream_filename = None
	one_frame_per_line = False
	i = 1
	while i < len(sys.argv):
		if sys.argv[i] == '-p':
			one_frame_per_line = True
		else:
			bitstream_filename = sys.argv[i]
		i += 1
	if not bitstream_filename:
		err_usage()
	
	hbitstream = hbitstream_from_file(bitstream_filename)
	for sync, frame in hbitstream:
		bits = [ (sync > 1) & 0x3, sync & 0x1 ]
		bits_str = ''
		for i in byte_range_reversed:
			byte = (frame >> i*8) & 0xff
			for j in bit_range:
				bits.append((byte >> j) & 0x1)
		for bit in bits:
			if one_frame_per_line:
				bits_str += '%d' % bit
			else:
				bits_str += '%d\n' % bit
		if one_frame_per_line:
			sys.stdout.write('%s\n' % bits_str)
		else:
			sys.stdout.write('%s' % bits_str)
#end main

if __name__ == "__main__":
	main()
