
# Copyright (C) 2009 Tudor Marian <tudor.marian@cornell.edu>

import sys,pickle,os,copy

def import_hbitstream(path):
	module_path, module_name = os.path.split(path)
	module_name, module_name_ext = os.path.splitext(module_name)
	old_module_path = None
	if module_path and module_path != '.':
		old_module_path = copy.copy(sys.path)
		del sys.path[:]
		sys.path.append(module_path)
	sys.stderr.write('expensive import?...\n')
	h = __import__(module_name)
	sys.stderr.write('Done w/ expensive import...\n')
	if old_module_path:
		sys.path = old_module_path
	return h.hbitstream
#end import_bitstream

def hbitstream_from_file(path):
	fd = open(path)
	hbitstream = []
	for line in fd:
		line = line.strip()
		if not line or line.startswith("hbitstream = [") or line.startswith("]"):
			continue
		pieces = line.split(',')
		sync = int(pieces[0][1:], 16)
		frame = int(pieces[1][1:19], 16)
		hbitstream.append((sync, frame))
	fd.close()
	return hbitstream
#end hbitstream_from_file 

def packet_list_from_file(fd):
	vector = []
	for line in fd:
		item = ''
		for byte_str in line.strip().split(','):
			item += chr(int(byte_str, 16))
		vector.append(item)
	return vector
#end read_packet_list_file 

def packet_list_to_file(packet_list, fd):
	for packet_str in packet_list:
		packet_str_len = len(packet_str)
		for i in range(packet_str_len):
			if i == packet_str_len-1:
				fd.write('%02x\n' % ord(packet_str[i]))
			else:
				fd.write('%02x,' % ord(packet_str[i]))
#end packet_list_to_file 
