
# Copyright (C) 2009 Tudor Marian <tudor.marian@cornell.edu>

tap1 = (63-57)
tap2 = (63-38)

def scramble(state, bit):
	# returns a tuple consisting of the (new state, output bit)
	bit = bit & 0x1
	obit = bit ^ (state >> tap1) ^ (state >> tap2)
	obit = obit & 0x1
	nstate = (state >> 1) | (obit << 63)
	return (nstate, obit)
#end scramble

def descramble(state, bit):
	# returns a tuple consisting of the (new state, output bit)
	bit = bit & 0x1
	obit = bit ^ (state >> tap1) ^ (state >> tap2)
	obit = obit & 0x1
	nstate = (state >> 1) | (bit << 63)
	return (nstate, obit)
#end descramble

#precompute the range for scrambler_MSB
range_MSB = range(63, -1, -1)
def scrambler_MSB(state, number, scramble_fn):
	ret_number = 0x0
	for i in range_MSB:
		bit = (number >> i) & 0x1
		state, bit = scramble_fn(state, bit)
		ret_number |= (bit << i)
	return (state, ret_number)
#end scrambler_MSB

# precompute ranges for scrambler_LSB
range_LSB_outer = range(64-8, -8, -8)
range_LSB_inner = range(8)
def scrambler_LSB(state, number, scramble_fn):
	ret_number = 0x0
	# this LSB nonsence is annoying
	for j in range_LSB_outer:
		for i in range_LSB_inner:
			bit = (number >> (j+i)) & 0x1
			state, bit = scramble_fn(state, bit)
			ret_number |= (bit << (j+i))
	return (state, ret_number)
#end scrambler_LSB

# the default scrambler
scrambler = scrambler_LSB
